darcs

Issue 2367 amend --unrecord should be more visible

Title amend --unrecord should be more visible
Priority wishlist Status resolved
Milestone Resolved in 2.10.0 HEAD
Superseder Nosy List bf, ganesh
Assigned To
Topics

Created on 2014-04-03.10:53:23 by bf, last changed 2014-04-19.17:08:05 by noreply.

Files
File name Uploaded Type Edit Remove
rename-amend_record-to-amend_-make-__unrecord-more-visible-in-help.dpatch gh, 2014-04-06.23:20:24 application/x-darcs-patch
rename-amend_record_plus1.dpatch bf, 2014-04-07.00:42:12 application/x-darcs-patch
Messages
msg17253 (view) Author: bf Date: 2014-04-03.10:53:22
1. Summarise the issue (what were doing, what went wrong?)

darcs amend-un<TAB> doesn't complete

2. What behaviour were you expecting instead?

That my zsh (or bash) completions know about the amend-unrecord alias.

3. What darcs version are you using? (Try: darcs --exact-version)

HEAD of screened repo

4. What operating system are you running?

linux
msg17254 (view) Author: bf Date: 2014-04-03.11:00:31
A bit more rationale.

I find amend-unrecord very useful and use it regularly. It is less
verbose that amend-record --unrecord and the name feels quite intuitive
to me. Listing it with --commands would give it more visibility which
would be a good thing IMO.
msg17270 (view) Author: ganesh Date: 2014-04-06.18:32:43
For what it's worth, it was a deliberate decision to hide it in order to 
preserve the default "amend" shorthand for "amend-record" - otherwise 
that would become ambiguous.

I'm happy to revisit that decision, just want to make the reason clear. 
We could also make the defaulting logic customisable so that amend 
remained as that abbreviation.
msg17271 (view) Author: gh Date: 2014-04-06.23:20:24
Indeed there is a visibility problem with the --unrecord flag, but I'm
not fond of the solution proposed by Ben. Instead of adding an extra
top-level commands (which I believe we would collectively resist), I'd
rather enhance how things are shown.

I'm attaching an alternative proposal that:

* lists --unrecord first in the help of amend
* trims obvious/unnecessary text from the help of amend and mention
--unrecord at the second paragraph
* renames amend-record to amend (leaves amend-record as alias)
* removes the amend-unrecord alias

The last two items seemed natural to me in that context. "amend" (or
"amend --add") is the default mode and "amend --unrecord" is the
substractive mode.

Try "darcs help amend" with that patch.
Attachments
msg17272 (view) Author: bf Date: 2014-04-06.23:51:04
I understand (and appreciate) that you guys want to keep the user
interface clean. GH's proposal is very nice and better than mine. 

Except for the naming of the default switch: --add should rather be
--record. Then we'd have

  darcs amend-record == darcs amend --record

while --add would be confusing since 'darcs add' does something
completely unrelated.
msg17273 (view) Author: bf Date: 2014-04-07.00:42:12
Here is a patch which changes --add to --record and slightly improves on
the wording of the option help text.
Attachments
msg17280 (view) Author: gh Date: 2014-04-07.18:41:18
I like it :) let's see if there are more reactions, and if there are
not (and you agree) I'll submit both patches in a couple of days.

2014-04-06 21:42 GMT-03:00 Ben Franksen <bugs@darcs.net>:
>
> Ben Franksen <benjamin.franksen@helmholtz-berlin.de> added the comment:
>
> Here is a patch which changes --add to --record and slightly improves on
> the wording of the option help text.
>
> __________________________________
> Darcs bug tracker <bugs@darcs.net>
> <http://bugs.darcs.net/issue2367>
> __________________________________
>
> _______________________________________________
> darcs-devel mailing list
> darcs-devel@darcs.net
> http://lists.osuosl.org/mailman/listinfo/darcs-devel
>
msg17329 (view) Author: gh Date: 2014-04-10.16:44:49
I'm updating the title of the issue to reflect the current proposal.
msg17360 (view) Author: noreply Date: 2014-04-19.17:08:04
The following patch sent by Guillaume Hoffmann <guillaumh@gmail.com> updated issue issue2367 with
status=resolved;resolvedin=2.10.0 HEAD

* resolve issue2367: rename amend-record to amend, make --unrecord more visible 
Ignore-this: 6da507ce5415b45b56dd0c81f988bdb3
also rename amend flag --add to --record
History
Date User Action Args
2014-04-03 10:53:23bfcreate
2014-04-03 11:00:33bfsetpriority: wishlist
messages: + msg17254
2014-04-06 18:32:44ganeshsetnosy: + ganesh
messages: + msg17270
2014-04-06 23:20:26ghsetfiles: + rename-amend_record-to-amend_-make-__unrecord-more-visible-in-help.dpatch
messages: + msg17271
2014-04-06 23:51:05bfsetmessages: + msg17272
2014-04-07 00:42:13bfsetfiles: + rename-amend_record_plus1.dpatch
messages: + msg17273
2014-04-07 18:41:19ghsetmessages: + msg17280
2014-04-10 16:44:51ghsetmessages: + msg17329
title: amend-unrecord should show up in darcs --commands -> amend --unrecord should be more visible
2014-04-19 17:08:05noreplysetstatus: unknown -> resolved
messages: + msg17360
resolvedin: 2.10.0 HEAD